
// This file was generated by a tool. 
// Changes to this file may cause incorrect behavior and will be lost if the file is regenerated. 

"use strict";

var TaiRoxSCAPaymentBatchListCustomizationUI = TaiRoxSCAPaymentBatchListCustomizationUI || {};
var TaiRoxSCAPaymentBatchListCustomizationViewModel;

var APPaymentBatchStatusEnum = {
    Open: 1,
    Posted: 3,
    Deleted: 4,
    PostInProgress: 5,
    ReadyToPost: 7,
    CheckCreationInProgress: 8,
};

TaiRoxSCAPaymentBatchListCustomizationUI = {

    language: "ENG",  // "ENG", "ESN", "FRA"
    resources: {},
    
    sageBatch: null,
    approvalBatch: null,

    // Init
    init: function () {
        console.log("SOX Check Approval: customization initialization begin");

        // hide the visible controls until we know the customization's requirements are met
        $("#btnTaiRoxWWApprove").hide();

        // we need to be able to latch onto the grid in order to do anything
        var grid = $('#PaymentBatchListGrid').data("kendoGrid");
        if (grid == null) {
            console.log("SOX Check Approval: grid with id='PaymentBatchListGrid' not found");
            return;
        };

        // we call services in the SOX Check Approval web app so check that it is accessible
        TaiRoxSCAPaymentBatchListCustomizationUI.checkPrerequisites();
    },

    checkPrerequisites: function () {
        var url = sg.utls.url.buildUrl("Customization", "TaiRoxSCACustomization", "IsSCAWebAppInstalled");
        $.ajax({
            type: 'get',
            dataType: 'json',
            cache: false,
            url: url,
            data: {},
            success: function (data) {
                TaiRoxSCAPaymentBatchListCustomizationViewModel = data.Data;
                //var jsonDataString = JSON.stringify(data.Data);
                //console.log("Data returned by IsSCAWebAppInstalled = " + jsonDataString);
                //sg.utls.showMessageInfo(sg.utls.msgType.ERROR, "Data returned by IsSCAWebAppInstalled = " + jsonDataString);
                if (data.Data.IsLicensed) {
                    TaiRoxSCAPaymentBatchListCustomizationUI.language = data.Data.Language;
                    TaiRoxSCAPaymentBatchListCustomizationUI.initCustomization();
                }
                else {
                    console.log("SOX Check Approval: SCAWebApp is NOT installed or is NOT licensed.");
                }
            },
            error: function (jqXHR, textStatus, error) {
                sg.utls.showMessageInfo(sg.utls.msgType.ERROR, "call to IsSCAWebAppInstalled failed - textStatus = [" + textStatus + "] error = [" + error + "]");
            }
        });
    },

    initCustomization: function () {
        TaiRoxSCAPaymentBatchListCustomizationUI.initLanguageResources();
        TaiRoxSCAPaymentBatchListCustomizationUI.initIntercept();
        TaiRoxSCAPaymentBatchListCustomizationUI.initAjaxCallIntercept();
        TaiRoxSCAPaymentBatchListCustomizationUI.initButtons();
        TaiRoxSCAPaymentBatchListCustomizationUI.initFinders();
        TaiRoxSCAPaymentBatchListCustomizationUI.initTextbox();
        TaiRoxSCAPaymentBatchListCustomizationUI.initNumericTextBox();
        TaiRoxSCAPaymentBatchListCustomizationUI.initDropDownList();
        TaiRoxSCAPaymentBatchListCustomizationUI.initDatePicker();
        TaiRoxSCAPaymentBatchListCustomizationUI.initCheckBoxes();
        TaiRoxSCAPaymentBatchListCustomizationUI.initGrid();
        TaiRoxSCAPaymentBatchListCustomizationUI.initOtherControls();

        var grid = $('#PaymentBatchListGrid').data("kendoGrid");
        grid.bind("dataBound", TaiRoxSCAPaymentBatchListCustomizationUI.grid_OnDataBound);
        grid.bind("change", TaiRoxSCAPaymentBatchListCustomizationUI.grid_OnChange);

        // There seems to be a race condition on screen initialization.
        // I **think** that some of the grid events are being fired before we have been initialized,
        // resulting in events being missed.
        // Try to correct the situation by pretending the current batch was just selected.

        var dataItem = null;
        var selectedRows = grid.select();  // this returns an array
        if (selectedRows.length > 0) {
            dataItem = grid.dataItem(selectedRows[0]);
        }
        if (dataItem == null) {
            //sg.utls.showMessageInfo(sg.utls.msgType.ERROR, "grid_OnChange: dataItem is null!");
            sg.controls.disable("#btnTaiRoxWWApprove");
            $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Not Submitted"));  // set caption to default
        }
        else {
            TaiRoxSCAPaymentBatchListCustomizationUI.batchSelected(dataItem, "Init");
        }

        $('#btnTaiRoxWWApprove').bind('click', TaiRoxSCAPaymentBatchListCustomizationUI.btnSCA_OnClick);

        $("#btnTaiRoxWWApprove").show();
    },

    btnSCA_OnClick: function () {
        if (TaiRoxSCAPaymentBatchListCustomizationUI.approvalBatch != null) {
            var guid = sg.utls.guid();
            var url = sg.utls.url.buildUrl("WW", "ApprovalStatus", "Index");
            var company = TaiRoxSCAPaymentBatchListCustomizationUI.approvalBatch.OrgId;
            var batch = TaiRoxSCAPaymentBatchListCustomizationUI.approvalBatch.BatchNumber;
            url += "?Company=" + company + "&Batch=" + batch;
            sg.utls.iFrameHelper.openWindow(guid, "", url);
        }
        else {
            TaiRoxSCAPaymentBatchListCustomizationUI.showSubmitDialog();

            //var guid = sg.utls.guid();
            //var url = sg.utls.url.buildUrl("WW", "SubmitBatch", "Index");
            //url += "?Batch=" + TaiRoxSCAPaymentBatchListCustomizationUI.sageBatch.BatchNumber;
            //sg.utls.iFrameHelper.openWindow(guid, "", url);
        }
    },

    showSubmitDialog: function () {
        var dialog = $('<div class="modelWindow" id="checkApprovalSubmitDialog"/>').kendoWindow({
            title: TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Confirmation"),
            resizable: false,
            modal: true,
            visible: false,
            open: function () {
                // For custom theme color
                sg.utls.setBackgroundColor($(this.element[0].previousElementSibling));
            },
        }).data('kendoWindow');
        dialog.content(TaiRoxSCAPaymentBatchListCustomizationUI.createSubmitDialogContent());
        dialog.center();
        dialog.open();

        // attach event handlers
        $('#checkApprovalSubmitDialog #btnNo').on('click', TaiRoxSCAPaymentBatchListCustomizationUI.btnNo_OnClick);
        $('#checkApprovalSubmitDialog #btnYes').on('click', TaiRoxSCAPaymentBatchListCustomizationUI.btnYes_OnClick);
    },

    btnNo_OnClick: function () {
        var dialog = $('#checkApprovalSubmitDialog').data('kendoWindow');
        dialog.close();
        dialog.destroy();
    },

    btnYes_OnClick: function () {
        var submitterEmail = "";
        TaiRoxSCAPaymentBatchListCustomizationUI.submitBatch(submitterEmail);  // do this before closing the window, closing will hide some of the delay
        var dialog = $('#checkApprovalSubmitDialog').data('kendoWindow');
        dialog.close();
        dialog.destroy();
    },

    submitBatch: function (submitterEmail) {
        var sageBatch = TaiRoxSCAPaymentBatchListCustomizationUI.sageBatch;  // short alias

        if (sageBatch == null) return;  // seems to be some race condition on screen initialization

        var url = sg.utls.url.buildUrl("Customization", "TaiRoxSCACustomization", "SubmitBatch");

        $.ajax({
            type: 'get',
            dataType: 'json',
            cache: false,
            url: url,
            data: {
                'batchNumber': sageBatch.BatchNumber,
                'submitterEmail': submitterEmail,
            },
            success: function (data) {
                TaiRoxSCAPaymentBatchListCustomizationUI.submitBatchCallback(data);
            },
            error: function (jqXHR, textStatus, error) {
            }
        });
    },

    submitBatchCallback: function (jsonResult) {
        sg.utls.showMessage(jsonResult.Data);  // display any submit messages/errors
        //TaiRoxSCAPaymentBatchListCustomizationUI.getBatchCallback(jsonResult);  // update button text

        if (jsonResult != null && jsonResult.Data != null && jsonResult.Data.UserMessage.IsSuccess) {
            // refresh the grid, retaining the selected row
            var grid = $('#PaymentBatchListGrid').data("kendoGrid");
            // get the selected batch
            var oldDataItem = grid.dataItem(grid.select()[0]);
            // refresh the current page in the grid's datasource
            grid.dataSource.read();
            // reselect the selected row AFTER allowing the grid some time to reload the page
            setTimeout(function () {
                grid.items().each(function () {
                    var dataItem = grid.dataItem(this);
                    //some condition
                    if (dataItem.BatchNumber == oldDataItem.BatchNumber) {
                        grid.select(this);
                    }
                });
            }, 500);
        }
    },

    createSubmitDialogContent: function () {
        var sageBatch = TaiRoxSCAPaymentBatchListCustomizationUI.sageBatch;  // short alias
        var question = TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Are you sure you want to submit batch {0} for approval?");
        var strYes = TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Yes");
        var strNo = TaiRoxSCAPaymentBatchListCustomizationUI.getResource("No");
        var prompt = jQuery.validator.format(question, sageBatch.BatchNumber);

        var content = '';
        content += '<div class="fild_set">';
            content += '<div class="fild_content">';
                   content += '<div style="padding-left: 3px; padding-right: 3px;">' + prompt + '</div>';
                content += '<div class="modelBox_controlls">';
                    content += '<input class="btn btn-secondary" type="button" id="btnNo" value="' + strNo + '"/>';
                    content += '<input class="btn btn-primary" type="button" id="btnYes" value="' + strYes + '"/>';
                content += '</div>';
            content += '</div>';
        content += '</div>';

        return content;
    },

    grid_OnDataBound: function (e) {
        var grid = e.sender;
        var dataItem = null;
        var selectedRows = grid.select();  // this returns an array
        if (selectedRows.length > 0) {
            dataItem = grid.dataItem(selectedRows[0]);
        }
        if (dataItem == null) {
            // no batches displayed
            sg.controls.disable("#btnTaiRoxWWApprove");
            $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Submit"));  // set caption to default
        }
        else {
            TaiRoxSCAPaymentBatchListCustomizationUI.batchSelected(dataItem, "OnDataBound");
        }
    },

    grid_OnChange: function (e) {
        var grid = e.sender;
        var dataItem = null;
        var selectedRows = grid.select();  // this returns an array
        if (selectedRows.length > 0) {
            dataItem = grid.dataItem(selectedRows[0]);
        }
        if (dataItem == null) {
            //sg.utls.showMessageInfo(sg.utls.msgType.ERROR, "grid_OnChange: dataItem is null!");
            sg.controls.disable("#btnTaiRoxWWApprove");
            $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Not Submitted"));  // set caption to default
        }
        else {
            TaiRoxSCAPaymentBatchListCustomizationUI.batchSelected(dataItem, "OnChange");
        }
    },

    batchSelected: function (dataItem, eventName) {
        if (dataItem == null)
            return;

        // The grid OnChange event is fired many times when a row is selected.
        // Try to cut down on the # of calls to the approval database service...
        if (eventName == "OnChange") {
            var priorBatch = TaiRoxSCAPaymentBatchListCustomizationUI.sageBatch;
            if (priorBatch != null && dataItem.BatchNumber == priorBatch.BatchNumber && dataItem.BatchStatus == priorBatch.BatchStatus) {
                TaiRoxSCAPaymentBatchListCustomizationUI.sageBatch = dataItem;  // remember the batch information
                return;
            }
        }

        TaiRoxSCAPaymentBatchListCustomizationUI.sageBatch = dataItem;  // remember the batch information

        // Get the batch's approval data from the approval database
        TaiRoxSCAPaymentBatchListCustomizationUI.getBatch();
    },

    getBatch: function () {
        var sageBatch = TaiRoxSCAPaymentBatchListCustomizationUI.sageBatch;  // short alias

        if (sageBatch == null) return;  // seems to be some race condition on screen initialization

        var url = sg.utls.url.buildUrl("Customization", "TaiRoxSCACustomization", "GetBatch");

        $.ajax({
            type: 'get',
            dataType: 'json',
            cache: false,
            url: url,
            data: { 'batchNumber': sageBatch.BatchNumber },
            success: function (data) {
                TaiRoxSCAPaymentBatchListCustomizationUI.getBatchCallback(data);
            },
            error: function (jqXHR, textStatus, error) {
                TaiRoxSCAPaymentBatchListCustomizationUI.sageBatch = null;
            }
        });
    },

    getBatchCallback: function (jsonResult) {
        if (jsonResult != null && jsonResult.Data != null) {
            TaiRoxSCAPaymentBatchListCustomizationUI.approvalBatch = jsonResult.Data.Batch;

            // create some shorter aliases
            var sageBatch = TaiRoxSCAPaymentBatchListCustomizationUI.sageBatch;
            var approvalBatch = TaiRoxSCAPaymentBatchListCustomizationUI.approvalBatch;

            var batchHasBeenSubmitted = (approvalBatch != null);
            var batchHasBeenApproved = batchHasBeenSubmitted && approvalBatch.Approved[approvalBatch.ApprovalLevels];

            if (sageBatch.BatchStatus == APPaymentBatchStatusEnum.Open || sageBatch.BatchStatus == APPaymentBatchStatusEnum.CheckCreationInProgress) {
                sg.controls.enable("#btnTaiRoxWWApprove");
                if (batchHasBeenSubmitted) {
                    if (batchHasBeenApproved) {
                        $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Approved"));
                    }
                    else {
                        $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("In Progress"));
                    }
                }
                else {
                    $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Submit"));
                }
            }
            else if (sageBatch.BatchStatus == APPaymentBatchStatusEnum.Posted ||
                sageBatch.BatchStatus == APPaymentBatchStatusEnum.ReadyToPost ||
                sageBatch.BatchStatus == APPaymentBatchStatusEnum.PostInProgress) {
                if (batchHasBeenSubmitted) {
                    sg.controls.enable("#btnTaiRoxWWApprove");
                    if (batchHasBeenApproved) {
                        $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Approved"));
                    }
                    else {
                        $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("In Progress"));
                    }
                }
                else {
                    $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Not Submitted"));
                    sg.controls.disable("#btnTaiRoxWWApprove");
                }
            }
            else {  // APPaymentBatchStatusEnum.Deleted
                sg.controls.disable("#btnTaiRoxWWApprove");
                $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Not Submitted"));  // set caption to default
            }

            // DEBUG - SHOW DURATION IN BUTTON TEXT
            //var text = $("#btnTaiRoxWWApprove").prop('value') + ' =>' + jsonResult.Data.Duration;
            //$("#btnTaiRoxWWApprove").prop('value', text);
        }
        else {
            var msg = "jsonResult is null or jsonResult.Data is null";
            sg.utls.showMessageInfo(sg.utls.msgType.ERROR, msg);
            sg.controls.disable("#btnTaiRoxWWApprove");
            $("#btnTaiRoxWWApprove").prop('value', TaiRoxSCAPaymentBatchListCustomizationUI.getResource("Submit"));  // set caption to default
        }
    },
    
    initLanguageResources: function () {
        var resources = {};
        if (TaiRoxSCAPaymentBatchListCustomizationUI.language == "FRA") {
            resources['In Progress'] = "En cours";
            resources['Approved'] = "Approuvé";
            resources['Submit'] = "Soumettre";
            resources['Not Submitted'] = "Non soumis";
            resources['Yes'] = "Oui";
            resources['No'] = "Non";
            resources['Confirmation'] = "Confirmation";
            resources['Are you sure you want to submit batch {0} for approval?'] = "Êtes-vous sûr de vouloir soumettre le lot {0} pour approbation?";
        }
        if (TaiRoxSCAPaymentBatchListCustomizationUI.language == "ESN") {
            resources['In Progress'] = "En Curso";
            resources['Approved'] = "Aprobado";
            resources['Submit'] = "Enviar";
            resources['Not Submitted'] = "No enviado";
            resources['Yes'] = "Sí";
            resources['No'] = "No";
            resources['Confirmation'] = "Confirmación";
            resources['Are you sure you want to submit batch {0} for approval?'] = "¿Está seguro de que desea enviar el lote {0} para su aprobación?";
        }
        TaiRoxSCAPaymentBatchListCustomizationUI.resources = resources;
    },

    //Hijack and intercept events, before the event
    initIntercept: function () {
    },

    //Intercept before/after Ajax calls
    initAjaxCallIntercept: function () {

        $(document).ajaxSend(function (event, jqxhr, settings) {
        });

        $(document).ajaxSuccess(function (event, xhr, settings) {
        });

    },

    // Init Buttons
    initButtons: function () {
    },

    // Init TextBoxs
    initTextbox: function(){
    },

    // Init Numeric TextBox
    initNumericTextBox: function () {
    },

    // Init Dropdown List
    initDropDownList: function () {
    },

    // Init Date Picker
    initDatePicker: function() {
        //$("#dtPickerCustom").kendoDatePicker({});
    },

    // Init Sage 300 Finders
    initFinders: function () {
        //sg.finderHelper.setFinder("btnCustomCurrencyFinder", sg.finder.TaxCurrencyFinder, TaiRoxSCAPaymentBatchListCustomizationUICallback.currencyCode, null, "Customization Currency Finder", sg.finderHelper.createDefaultFunction("txtCustomCurrency", "CurrencyCodeId", sg.finderOperator.StartsWith), null, true);
    },

    //Init CheckBoxs
    initCheckBoxes: function () {
    },

    //Init kendo Grid
    initGrid: function () {
    },

    //Init Other type controls
    initOtherControls: function () {
    },
    
    getResource: function (en_string) {
        var rsc = en_string;
        if (TaiRoxSCAPaymentBatchListCustomizationUI.language != "ENG")
        {
            var rsc = TaiRoxSCAPaymentBatchListCustomizationUI.resources[en_string];
            if (rsc === undefined)
                rsc = en_string;
        }
            
        //var msg = "language=" + TaiRoxSCAPaymentBatchListCustomizationUI.language + ";  looking for = [" + en_string + "];  found = [" + rsc + "]";
        //sg.utls.showMessageInfo(sg.utls.msgType.ERROR, msg);
        return rsc;
    },
};


var TaiRoxSCAPaymentBatchListCustomizationUICallback = {
};

// Initial Entry
$(function () {
    TaiRoxSCAPaymentBatchListCustomizationUI.init();
});
